/********************************************************
 * MAT 259 - Winter 2017                                *
 * Final project                                        *    
 *                                                      *
 * Author: Jingi Xiao                                   *
 * Supervisor: George Legrady                           *
 *                                                      *
 * Purpose:   *
 *                                                      *
 *                                                      *
 ********************************************************/

import peasy.*;
PeasyCam cam;

import controlP5.*;
ControlP5 cp5;
CheckBox checkbox1, checkbox2; //checkbox3, checkbox4, checkbox5, checkbox6, checkbox7;
RadioButton radiobutton1, radiobutton2,radiobutton3, radiobutton4, radiobutton5, radiobutton6;
Textlabel textlabel1, textlabel2, textlabel3, textlabel4, textlabel5, textlabel6, textlabel7, textlabel8;
DropdownList ddl;
Range range;

int[] fontColor = {50, 70};
int[] fontSize = {28, 14, 12, 10};

Table table1, table2;
PFont font;
ArrayList<interviewee> data = new ArrayList<interviewee>();
int radius = 800;
int sc = 2; /// scale
String[] activity ={"Personal Care", "Household Activities", "Caring For & Helping Household Members", 
"Caring For & Helping NonHH Members", "Work & Work-Related Activities", "Education", "Consumer Purchases",
"Professional & Personal Care Services", "Household Services", "Government Services & Civic Obligations",
"Eating and Drinking", "Socializing, Relaxing, and Leisure", "Sports, Exercise, and Recreation",
"Religious and Spiritual Activities", "Volunteer Activities", "Telephone Calls", 
"Traveling", "Others"};

String[] location={"AL","AK","","AZ","AR","CA","","CO","CT","DE","DC","FL","GA","", "HI","ID", "IL","IN","IA","KS",
"KY","LA","ME","MD","MA","MI","MN","MS","MO","MT", "NE", "NV","NH","NJ","NM","NY","NC","ND","OH","OK","OR",
"PA","","RI","SC","SD","TN","TX","UT","VT","VA","","WA","WV","WI","WY"};

int  state1=0, state2=56, age1=0, age2=24, salary1=-1, salary2=-1, week1=2, week2=6, workhour1=-1, workhour2=-1;
boolean gender = true, child =false, elder = false;
int time1=0, time2=24;

//color clr[] = {#F6A8DE, #BFB7F0, #C4AD49, #48CAD2, #FC913A, #F9D423, #9DE0AD, #F8B195, #E49C51, #F68C6B,
//#53C0F0, #FF847C, #61C7E2, #B6A4D9, #85BAE5, #53CDDD, #E58C59, #47DAC3};

color clr[] = {#EDA3D8, #EA86A6, #BB99CB, #89BAE7, #41CCB9, #C9B2EB, #EAB451, #CAA246, #F18F61,
#63C6E2, #4DD9B8, #9BDF7D, #F3D65C, #F09B58, #EB8960, #EA85A4, #BEA6DB, #94C4F4};

//#F38474
boolean overview= false, info = true, annotation = false, rotate= true, label = false;
int labelI=-1, alpha=70;

void setup() {
  size(1280, 720, P3D);
  pixelDensity(2);
  cam = new PeasyCam(this, 0, 0, 0, 3000);
  cam.setWheelScale(0.2);
  //cam.setMinimumDistance(-2000);
  //cam.setMaximumDistance(3000);

  font = loadFont("SansSerif-24.vlw");
  textFont(font);

  table1 = loadTable("activity_2015.csv", "header");
  table2 = loadTable("info_2015.csv","header");
  
  int numRows = table1.getRowCount();
  
  
  ArrayList<ArrayList<int[]>> list = new ArrayList<ArrayList<int[]>>();
  for(int i=0; i<10905; i++){
    ArrayList<int[]> st = new ArrayList<int[]>();
    list.add(st);
  }
  
  for (int i=0; i<numRows-1; i++) {
    int a[] = {0,0};
    if(table1.getInt(i, 1) == 50)
     a[0] = 17;
    else
     a[0] = table1.getInt(i, 1);
     
     a[1] = table1.getInt(i, 2);
    list.get(table1.getInt(i, 0)).add(a);
  }
  
  boolean gd, cl, el;
  int wk;
  for (int i=0; i<10905; i++){
    data.add(new interviewee(list.get(i)));
    //int state, int age,  int week, int salay, int workhour, boolean gender, boolean child, boolean elder
    
    if(table2.getInt(i,3) == 1) gd = true; else gd = false;
    if(table2.getInt(i,7) > 0 ) cl = true; else cl = false;
    if(table2.getInt(i,8) > 1) el = true; else el = false;
    if(table2.getInt(i,6) == 7) wk = 0; else wk = table2.getInt(i,6);
    float a = random(-PI/72,PI/72);
    data.get(i).info(table2.getInt(i,1),table2.getInt(i,2),gd,wk,table2.getInt(i,4), table2.getInt(i,5), cl, el, a);
  }
  
  gui();
 
  //println(location.length);
}

void draw() {
  background(250);
  
 
  drawData();
  
  /// keep cp5 on the top of 3D without rotation when camera angle changes
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  cp5.draw();
   drawInfo();
  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);
  
  
  /// when interact with cp5, keep camera still.
  if (cp5.getWindow().isMouseOver()) {
    cam.setActive(false);
  } else {
    cam.setActive(true);
  }
  
}